#pragma once

#include <string>
#include <glm/glm.hpp>

namespace ofxVariableLab {

struct FontVariationAxis {
    char * name;
    float minValue;
    float maxValue;
    float defaultValue;
};

struct FontVariation {
    char * name;
    float value;
};

template <class T>
inline void hash_combine(std::size_t & seed, const T & v){
    std::hash <T> hasher;
    seed ^= hasher(v) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
}
enum VFlipState {
    V_FLIP_UNKNOWN = 0,
    V_FLIP_ON,
    V_FLIP_OFF
};
enum VFlipBehaviour {
    /// probe view matrix every frame
    V_FLIP_ALWAYS_AUTO = 0,
    /// probe view matrix once and remember
    V_FLIP_ONCE_AUTO,
    /// never probe and force off
    V_FLIP_ALWAYS_OFF,
    /// never probe and force on
    V_FLIP_ALWAYS_ON
};
void getVFlip(const VFlipBehaviour & vFlipBehaviour,
              const glm::mat4 & orientationMatrix,
              VFlipState & vFlip);

}
